unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    GroupBox1: TGroupBox;
    Button1: TButton;
    GroupBox2: TGroupBox;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  protected
    function GetButtonCaption: string;
    procedure SetButtonCaption(const Value: string);
  public
    property ButtonCaption : string read GetButtonCaption write SetButtonCaption;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  System.TypInfo, System.Rtti, Mitov.TypeInfo;

const
  VisibilityStrings : array [ TMemberVisibility ] of String =
  (
    'Private',
    'Protected',
    'Public',
    'Published'
  );

procedure TForm1.Button1Click(Sender: TObject);
var
  AContext          : TRttiContext;
  AType             : TRttiType;
  AField            : TRttiField;
  ASingleProperty   : TRttiProperty;
  AIndexedProperty  : TRttiIndexedProperty;
  AParametersString : String;
  AMethod           : TRttiMethod;
  AParameter        : TRttiParameter;

begin
  Memo1.Lines.BeginUpdate();
  Memo1.Lines.Clear();
  AType := AContext.GetType( Form1.ClassType() );

  Memo1.Lines.Add( 'Form1 limited RTTI information :' );
  Memo1.Lines.Add( '' );

  Memo1.Lines.Add( AType.Name );

  Memo1.Lines.Add( '' );
  Memo1.Lines.Add( 'Fields :' );
  Memo1.Lines.Add( '' );

  for AField in AType.GetFields() do
    Memo1.Lines.Add( '  ' + VisibilityStrings[ AField.Visibility ] + ': ' + AField.Name + ' : ' + AField.FieldType.Name + ' = ' + AField.GetValue( Form1 ).ToString() );

  Memo1.Lines.Add( '' );
  Memo1.Lines.Add( 'Single Properties :' );
  Memo1.Lines.Add( '' );

  for ASingleProperty in AType.GetProperties() do
    if( ASingleProperty.Name <> 'ComObject' ) then // The ComObject getter generates exception. We don't want to invoke it
      Memo1.Lines.Add( '  ' + VisibilityStrings[ ASingleProperty.Visibility ] + ': ' + ASingleProperty.Name + ' : ' + ASingleProperty.PropertyType.Name + ' = ' + ASingleProperty.GetValue( Form1 ).ToString() );

  Memo1.Lines.Add( '' );
  Memo1.Lines.Add( 'Indexed Properties :' );
  Memo1.Lines.Add( '' );

  for AIndexedProperty in AType.GetIndexedProperties() do
    begin
    // No methods to get indexes information. Use Mitov.TypeInfo to get this information
    Memo1.Lines.Add( '  ' + VisibilityStrings[ AIndexedProperty.Visibility ] + ': ' + AIndexedProperty.Name + '[ ??? ]' + ' : ' + AIndexedProperty.PropertyType.Name );
    end;

  for AMethod in AType.GetMethods() do
    begin
    AParametersString := '';
    for AParameter in AMethod.GetParameters() do
      begin
      if( AParametersString <> '' ) then
        AParametersString := AParametersString + ', ';

      if( AParameter.ParamType = NIL ) then
        AParametersString := AParametersString + AParameter.Name

      else
        AParametersString := AParametersString + AParameter.Name + ' : ' + AParameter.ParamType.Name;

      end;

    if( AMethod.ReturnType <> NIL ) then
      Memo1.Lines.Add( '  ' + VisibilityStrings[ AMethod.Visibility ] + ': function ' + AMethod.Name + '( ' + AParametersString + ' )' + ' : ' + AMethod.ReturnType.Name )

    else
      Memo1.Lines.Add( '  ' + VisibilityStrings[ AMethod.Visibility ] + ': procedure ' + AMethod.Name + '( ' + AParametersString + ' )' )

    end;

  Memo1.Lines.EndUpdate();
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  ATypeInfo         : ITypeInfo;
  AField            : IFieldInfo;
  ASingleProperty   : ISinglePropertyInfo;
  AIndexedProperty  : IIndexedPropertyInfo;
  AIndexesString    : String;
  AParametersString : String;
  AParameter        : IParameterInfo;
  AMethod           : IMethodInfo;

begin
  Memo1.Lines.BeginUpdate();
  Memo1.Lines.Clear();

  Memo1.Lines.Add( 'Button1.Caption: '+ButtonCaption );
  Memo1.Lines.Add( '' );

  ATypeInfo := Form1.TypeInfo();

  Memo1.Lines.Add( 'Form1 full RTTI information :' );
  Memo1.Lines.Add( '' );

  Memo1.Lines.Add( ATypeInfo.Name );

  Memo1.Lines.Add( '' );
  Memo1.Lines.Add( 'Fields :' );
  Memo1.Lines.Add( '' );

  for AField in ATypeInfo.DeclaredFields do
    Memo1.Lines.Add( '  ' + VisibilityStrings[ AField.Visibility ] + ': ' + AField.Name + ' : ' + AField.TypeInfo.Name + ' = '
                      + AField.Value[ Form1 ].ToString() );

  Memo1.Lines.Add( '' );
  Memo1.Lines.Add( 'Single Properties :' );
  Memo1.Lines.Add( '' );

  for ASingleProperty in ATypeInfo.DeclaredSingleProperties do
    if( ASingleProperty.Name <> 'ComObject' ) then // The ComObject getter generates exception. We don't want to invoke it
      Memo1.Lines.Add( '  ' + VisibilityStrings[ ASingleProperty.Visibility ] + ': ' + ASingleProperty.Name + ' : '
                        + ASingleProperty.TypeInfo.Name + ' = ' + ASingleProperty.Value[ Form1 ].ToString() );

  Memo1.Lines.Add( '' );
  Memo1.Lines.Add( 'Indexed Properties :' );
  Memo1.Lines.Add( '' );

  for AIndexedProperty in ATypeInfo.DeclaredIndexedProperties do
    begin
    for AParameter in AIndexedProperty.Indexes do
      begin
      if( AIndexesString <> '' ) then
        AIndexesString := AIndexesString + ', ';

      AIndexesString := AIndexesString + AParameter.Name + ' : ' + AParameter.TypeInfo.Name;
      end;

    Memo1.Lines.Add( '  ' + VisibilityStrings[ AIndexedProperty.Visibility ] + ': ' + AIndexedProperty.Name
                      + '[ ' + AIndexesString + ' ]' + ' : ' + AIndexedProperty.TypeInfo.Name );
    end;

  Memo1.Lines.Add( '' );
  Memo1.Lines.Add( 'Methods :' );
  Memo1.Lines.Add( '' );

  for AMethod in ATypeInfo.Methods do
    begin
    AParametersString := '';
    for AParameter in AMethod.Parameters do
      begin
      if( AParametersString <> '' ) then
        AParametersString := AParametersString + ', ';

      if( AParameter.TypeInfo = NIL ) then
        AParametersString := AParametersString + AParameter.Name

      else
        AParametersString := AParametersString + AParameter.Name + ' : ' + AParameter.TypeInfo.Name;

      end;

    if( AMethod.TypeInfo <> NIL ) then
      Memo1.Lines.Add( '  ' + VisibilityStrings[ AMethod.Visibility ] + ': function ' + AMethod.Name
                        + '( ' + AParametersString + ' )' + ' : ' + AMethod.TypeInfo.Name )

    else
      Memo1.Lines.Add( '  ' + VisibilityStrings[ AMethod.Visibility ] + ': procedure ' + AMethod.Name
                        + '( ' + AParametersString + ' )' )

    end;

  Memo1.Lines.EndUpdate();
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  ATypeInfo : ITypeInfo;

begin
  Memo1.Lines.BeginUpdate();
  Memo1.Lines.Clear();
  ATypeInfo := Form1.TypeInfo();
  Memo1.Lines.Add( ATypeInfo.Name );
  Memo1.Lines.Add( '' );
  Memo1.Lines.Add( 'Fields :' );
  Memo1.Lines.Add( '' );

  ATypeInfo.Fields.Query().ForEach(
      procedure( AField : IFieldInfo )
      begin
        Memo1.Lines.Add( '  ' + VisibilityStrings[ AField.Visibility ] + ': ' + AField.Name + ' : ' + AField.TypeInfo.Name + ' = ' + AField.Value[ Form1 ].ToString() );
      end
    );

  Memo1.Lines.Add( '' );
  Memo1.Lines.Add( 'Single Properties :' );
  Memo1.Lines.Add( '' );

  ATypeInfo.SingleProperties.Query().ForEach(
      procedure( AProperty : ISinglePropertyInfo )
      begin
        if( AProperty.Name <> 'ComObject' ) then // The ComObject getter generates exception. We don't want to invoke it
          Memo1.Lines.Add( '  ' + VisibilityStrings[ AProperty.Visibility ] + ': ' + AProperty.Name + ' : ' + AProperty.TypeInfo.Name + ' = ' + AProperty.Value[ Form1 ].ToString() );

      end
    );

  Memo1.Lines.Add( '' );
  Memo1.Lines.Add( 'Indexed Properties :' );
  Memo1.Lines.Add( '' );

  ATypeInfo.IndexedProperties.Query().ForEach(
      procedure( AProperty : IIndexedPropertyInfo )
      var
        AIndexesString : String;

      begin
        AProperty.Indexes.Query().ForEach(
            procedure( AIndex : IParameterInfo )
            begin
              if( AIndexesString <> '' ) then
                AIndexesString := AIndexesString + ', ';

              AIndexesString := AIndexesString + AIndex.Name + ' : ' + AIndex.TypeInfo.Name;
            end
          );

        Memo1.Lines.Add( '  ' + VisibilityStrings[ AProperty.Visibility ] + ': ' + AProperty.Name + '[ ' + AIndexesString + ' ]' + ' : ' + AProperty.TypeInfo.Name );
      end
    );

  Memo1.Lines.Add( '' );
  Memo1.Lines.Add( 'Methods :' );
  Memo1.Lines.Add( '' );

  ATypeInfo.Methods.Query().ForEach(
      procedure( AMethod : IMethodInfo )
      var
        AParametersString : String;

      begin
        AMethod.Parameters.Query().ForEach(
            procedure( AParameter : IParameterInfo )
            begin
              if( AParametersString <> '' ) then
                AParametersString := AParametersString + ', ';

              if( AParameter.TypeInfo = NIL ) then
                AParametersString := AParametersString + AParameter.Name

              else
                AParametersString := AParametersString + AParameter.Name + ' : ' + AParameter.TypeInfo.Name;

            end
          );

        if( AMethod.TypeInfo <> NIL ) then
          Memo1.Lines.Add( '  ' + VisibilityStrings[ AMethod.Visibility ] + ': function ' + AMethod.Name + '( ' + AParametersString + ' )' + ' : ' + AMethod.TypeInfo.Name )

        else
          Memo1.Lines.Add( '  ' + VisibilityStrings[ AMethod.Visibility ] + ': procedure ' + AMethod.Name + '( ' + AParametersString + ' )' )

      end
    );

  Memo1.Lines.EndUpdate();
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Memo1.Lines.BeginUpdate();
  Memo1.Lines.Clear();
  Memo1.Lines.Add( 'All Form1 members:' );
  Memo1.Lines.Add( '' );

  Form1.TypeInfo().Members.Query().ForEach(
      procedure( AMember : IMemberInfo )
      begin
        if( AMember.TypeInfo <> NIL ) then
          Memo1.Lines.Add( '  ' + VisibilityStrings[ AMember.Visibility ] + ': ' + AMember.Name + ' : ' + AMember.TypeInfo.Name )

        else
          Memo1.Lines.Add( '  ' + VisibilityStrings[ AMember.Visibility ] + ': ' + AMember.Name );

      end
    );

  Memo1.Lines.EndUpdate();
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Memo1.Lines.BeginUpdate();
  Memo1.Lines.Clear();
  Memo1.Lines.Add( 'Integer Form1 properties:' );
  Memo1.Lines.Add( '' );

  Form1.TypeInfo().GetSingleProperties(
      function( AProperty : ISinglePropertyInfo ) : Boolean
      begin
        Result := ( AProperty.TypeInfo = TRttiInfo.TypeOf<Integer>());
      end
   ).Query().ForEach(
       procedure( AProperty : ISinglePropertyInfo )
       begin
         Memo1.Lines.Add( '  ' + VisibilityStrings[ AProperty.Visibility ] + ': ' + AProperty.Name + ' : ' + AProperty.TypeInfo.Name );
       end
     );

  Memo1.Lines.EndUpdate();
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  Memo1.Lines.BeginUpdate();
  Memo1.Lines.Clear();
  Memo1.Lines.Add( 'Types per package (If compiled without runtime packages there will be only single EXE package):' );

  TRttiInfo.Packages.Query().ForEach(
      procedure( APackage : IPackageInfo )
      begin
        Memo1.Lines.Add( '' );
        Memo1.Lines.Add( '  in ' + APackage.Name + ':' );
        Memo1.Lines.Add( '' );
        APackage.Types.Query().ForEach(
            procedure( AType : ITypeInfo )
            begin
              if( AType.BaseType <> NIL ) then
                Memo1.Lines.Add( '    ' + AType.Name + ' = inherits( ' + AType.BaseType.Name + ' )' )

              else
                Memo1.Lines.Add( '    ' + AType.Name );

            end
          );

      end
    );

  Memo1.Lines.EndUpdate();
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  Memo1.Lines.BeginUpdate();
  Memo1.Lines.Clear();
  Memo1.Lines.Add( 'All enums:' );
  Memo1.Lines.Add( '' );

  TRttiInfo.Types.Query().ForEach(
      procedure( AType : ITypeInfo )
      begin
        if( AType.TypeKind <> tkEnumeration ) then
          Exit;

        Memo1.Lines.Add( '  ' + AType.Name + ':' );
        ( AType as IEnumerationTypeInfo ).Values.Query().ForEach(
            procedure( AValue : IEnumerationValueInfo )
            begin
              Memo1.Lines.Add( '    ' + AValue.Name + ' = ' + IntToStr( AValue.Value ) );
            end
          );

        Memo1.Lines.Add( '' );
      end
    );

  Memo1.Lines.EndUpdate();
end;

procedure TForm1.Button8Click(Sender: TObject);
var
  I       : Integer;
  AMethod : IMethodInfo;
  APoint  : TPoint;

begin
  Memo1.Lines.BeginUpdate();
  Memo1.Lines.Clear();
  Memo1.Lines.Add( 'Call ClientToScreen for each control:' );
  Memo1.Lines.Add( '' );

  for I := 0 to ControlCount - 1 do
    if( Controls[ I ].TypeInfo.GetMethod( 'ClientToScreen', AMethod )) then
      begin
      APoint := AMethod.Invoke( Controls[ I ], [ TValue.From( TPoint.Create( 20, 30 )) ] ).AsType<TPoint>();
      Memo1.Lines.Add( Controls[ I ].Name + '.ClientToScreen( ( 20, 30 ) ) -> (' + APoint.X.ToString() + ', ' + APoint.Y.ToString() + ')' );
      end;

  Memo1.Lines.EndUpdate();
end;

function TForm1.GetButtonCaption: string;
begin
  Result := Button1.Caption;
end;

procedure TForm1.SetButtonCaption(const Value: string);
begin
  Button1.Caption := Value;
end;

end.
